public class Semaphore {
    private int count;

    public Semaphore(int n)
    {
        this.count=n;
    }

    public synchronized void acquire()
    {
        while (count==0)
            try
            {
                //System.out.println("Can't Acquire... Waiting...");
                wait();
            }
            catch (InterruptedException e)
            {
                System.err.println(e);
            }
            
        //System.out.println("Acquired... Running!");
        count--;
    }

    public synchronized void release()
    {
        //System.out.println("Releasing Semaphore, Notifying Waiting thread");
        count++;
        notify();
    }
}